function afinador

    % Initialize variables
    global note;
    Fs=44100;
    recObj = audiorecorder(Fs, 16, 2);
    
    % Initialize GUI
    afinador_gui;
    
    % Tuner loop
    while (true)
        data = record_sound(recObj);
        signal_fft = get_fft_and_plot(data);
        frequency = get_signal_frequency(data, signal_fft);
        get_error(note, frequency);
        pause(0.5);
    end

end

function data = record_sound(recObj)
    Fs=44100;
    % Record input sound for 0.5 seconds
    disp('Start recording...')
    recordblocking(recObj, 0.5);
    disp('End of Recording.');

    % Get data from recording file
    data = getaudiodata(recObj);
end

function y = get_fft_and_plot(data)

    Fs=44100;
    [L,c] = size(data);
    %NFFT = 2^nextpow2(L); % Next power of 2 from length of y
    NFFT=L;
    Y = fft(data,NFFT)/L;
    f = Fs/2 * linspace(0,1,NFFT/2+1);
    
    % Plot single-sided amplitude spectrum.
    y = abs(Y(1:NFFT/2+1));
    
    % Handle GUI
    global gui_handles;
    plot(gui_handles.axes2, f, y); 
    
end

function frequency = get_signal_frequency(data, signal_fft)

    Fs=44100;
    
    [L,c] = size(data);
    [maxPeak, maxFreq] = max(signal_fft);
    
    frequency =  maxFreq * Fs / L;
    disp(sprintf('Frequencia captada: %.3f', frequency));
    
    % Handle GUI
    global gui_handles;
    s1 = int2str(frequency);
    s2 = ' [Hz]';
    string = strcat(s1, s2);
    set(gui_handles.captada, 'String', string);
    
end

function error = get_error(note, frequency)
    error = (frequency - note)/note * 100;
    disp(sprintf('Erro: %.3f', error));

    % Handle GUI
    global gui_handles;
    s1 = int2str(error);
    s2 = ' %';
    string = strcat(s1, s2);
    set(gui_handles.erro, 'String', string);
    
    set_result(frequency);
    
end

function set_result(result)

    global note;
    global gui_handles;

    if((result < 0.9*note) || (result > 1.1*note))
        set(gui_handles.resultado, 'String', 'Desafinada');
    elseif ((result >= 0.9*note) || (result <= 1.1*note))
        set(gui_handles.resultado, 'String', 'Afinada');
    end
        
end